
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2

//---- input parameters
extern string TimeFrame       = "Current time frame";
extern int Lines_Break=3;//******************
//---- buffers
double HighBuffer[];
double LowBuffer[];
double Swing[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name;
   IndicatorBuffers(3);
   SetIndexBuffer(0,HighBuffer);
   SetIndexBuffer(1,LowBuffer);
   SetIndexBuffer(2,Swing);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   

         indicatorFileName = WindowExpertName();
         timeFrame         = stringToTimeFrame(TimeFrame);
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }

   short_name="3LineBreak";
      IndicatorShortName(short_name);
      SetIndexLabel(0,short_name);
      SetIndexLabel(1,short_name);
      SetIndexDrawBegin(0,10);
      SetIndexDrawBegin(1,10);
   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { HighBuffer[0] = MathMin(limit+1,Bars-1); return(0); }

   if (timeFrame != Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for(int i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            Swing[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lines_Break,2,y);
            if (Swing[i]== 1) { HighBuffer[i]=High[i]; LowBuffer[i]=Low[i]; }
            if (Swing[i]==-1) { LowBuffer[i]=High[i]; HighBuffer[i]=Low[i]; }
      }            
      return(0);
   }      

   for (int shift=limit; shift>=0;shift--)
   {
      if (shift==Bars-1) { Swing[shift]=1; continue; }
      double OLDSwing=Swing[shift+1];
         Swing[shift]= Swing[shift+1];

         double VALUE1=High[Highest(NULL,0,MODE_HIGH,Lines_Break,shift+1)];
         double VALUE2= Low[Lowest(NULL,0,MODE_LOW,Lines_Break,shift+1)];
            if (OLDSwing== 1 && Low[shift] <VALUE2) Swing[shift]=-1;
            if (OLDSwing==-1 && High[shift]>VALUE1) Swing[shift]= 1;

         HighBuffer[shift] = EMPTY_VALUE;
         LowBuffer[shift]  = EMPTY_VALUE;
         if (Swing[shift]== 1) { HighBuffer[shift]=High[shift]; LowBuffer[shift]=Low[shift]; }
         if (Swing[shift]==-1) { LowBuffer[shift]=High[shift]; HighBuffer[shift]=Low[shift]; }
         
      }
      return(0);
  }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}